<template>
  <el-main>
    <el-row>
      <el-col :sm="{span: 10, offset: 7}" :md="{span: 8, offset: 8}" :lg="{span: 6, offset: 8}">
        <h2>Sign up</h2>
        <el-form ref="form_sign_up" :model="user" :rules="rules" status-icon>
          <h3>User information</h3>

          <el-form-item label="Username" prop="username" required :error="errors.username">
            <el-input v-model="user.username"></el-input>
          </el-form-item>

          <el-form-item label="Email" prop="emails.0.email" :error="errors.emails_0_email">
            <el-input v-model="user.emails[0].email"></el-input>
          </el-form-item>

          <el-form-item label="Password" prop="password" required :error="errors.password">
            <el-input v-model="user.password" type="password"></el-input>
          </el-form-item>

          <el-form-item label="Password confirmation" prop="passwordConfirmation" required :error="errors.password_confirmation">
            <el-input v-model="user.passwordConfirmation" type="password"></el-input>
          </el-form-item>

          <h3>Personal information</h3>

          <el-form-item label="First name" prop="profile.firstName" required>
            <el-input v-model="user.profile.firstName"></el-input>
          </el-form-item>

          <el-form-item label="Last name" prop="profile.lastName" required>
            <el-input v-model="user.profile.lastName"></el-input>
          </el-form-item>

          <el-form-item label="Brithdate" prop="profile.birthdate" required>
            <el-date-picker type="date" v-model="user.profile.birthdate" style="width: 100%"></el-date-picker>
          </el-form-item>

          <el-form-item label="Gender" prop="profile.gender" required>
            <el-select v-model="user.profile.gender" style="width: 100%">
              <el-option label="Male" value="male"></el-option>
              <el-option label="Female" value="female"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="Country" prop="profile.country" required>
            <el-select v-model="user.profile.country" style="width: 100%">
              <el-option label="Venezuela" value="VE"></el-option>
            </el-select>
          </el-form-item>

          <h3>Terms and conditions</h3>

          <el-form-item prop="terms" :error="errors.terms">
            <el-switch v-model="user.terms" active-text="I accept the terms and conditions"></el-switch>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Sign up
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>

    <auth-links current="sign_up"></auth-links>
  </el-main>
</template>

<script>
import gql from 'graphql-tag'
import AuthLinks from '../components/auth_links'

export default {
  components: { 'auth-links': AuthLinks },

  data() {
    return {
      user: {
        username: '',
        password: '',
        passwordConfirmation: '',
        emails: [{ email: '' }],
        profile: {
          firstName: '',
          lastName: '',
          birthdate: '',
          gender: '',
          country: ''
        },
        terms: false
      },
      rules: {
        emails: [{ email: [
          { required: true, message: 'email is required' },
          { type: 'email',  message: 'email is invalid' }
          ] }],
        password_confirmation: { required: true, message: 'password confirmation is required' }
      },
      errors: {
        username: '',
        password: '',
        password_confirmation: '',
        emails_0_email: '',
        profile_first_name: '',
        profile_last_name: '',
        profile_birthdate: '',
        profile_gender: '',
        profile_country: '',
        terms: ''
      }
    }
  },

  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($user: SignUpInput!) {
          signUp(user: $user) {
            success
            message
            errors { field message }
          }
        }`,
        variables: {
          user: this.$refs['form_sign_up'].model
        },
        update: (store, { data: { signUp }}) => {
          if(signUp.success) {
            this.$msgbox({
              type: 'success',
              message: 'Sign up successfully',
              callback: action => { window.location.href = '/' }
            })
          }
          else {
            this.$message.error('Failed to create user')
            signUp.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    }
  }
}
</script>
